variables:
    RUN_LINTER: "true"
    RUN_TESTS: "true"
    PUBLISH_PACKAGE: "false"
    BUILD_DOCKER_IMAGE: "true"
    POETRY_PARAMS: ""


stages:
  - lint_and_test
  - publish_package
  - build_docker_image
  - deploy


.lint_and_test_common: &lint_and_test_common
  stage: lint_and_test
  image: python:3.10
  before_script:
    - apt-get -qq update && apt-get -qq install libdbus-1-3 libgl1 libxkbcommon-x11-0 libegl1  # additional dependencies for OpenCV,PyQt6
    - python -V
    - python -m venv .venv
    - source .venv/bin/activate
    - python -m pip install --upgrade pip
    - python -m pip install poetry
    - poetry install $POETRY_PARAMS


lint:
  <<: *lint_and_test_common
  script:
    - make lint
  rules:
    - if: $RUN_LINTER == "true" && $RUN_TESTS == "false"


test:
  <<: *lint_and_test_common
  script:
    - make test
  rules:
    - if: $RUN_LINTER == "false" && $RUN_TESTS == "true"


lint_and_test:
  <<: *lint_and_test_common
  script:
    - make lint
    - make test
    - coverage xml
  coverage: '/(?i)total.*? (100(?:\.0+)?\%|[1-9]?\d(?:\.\d+)?\%)$/'
  artifacts:
    reports:
      coverage_report:
        coverage_format: cobertura
        path: coverage.xml
  rules:
    - if: $RUN_TESTS == "true"


publish_package:
  stage: publish_package
  image: python:3.10
  before_script:
    - python -V
    - python -m pip install --upgrade pip
    - python -m pip install poetry
  script:
    - poetry build
    - poetry config repositories.gitlab "https://gitlab.com/api/v4/projects/$CI_PROJECT_ID/packages/pypi"
    - poetry config http-basic.gitlab gitlab-ci-token "$CI_JOB_TOKEN"
    - poetry publish --repository gitlab
  when: manual
  rules:
    - if: $PUBLISH_PACKAGE == "true" && $CI_COMMIT_BRANCH == "main"


build_docker_image:
  stage: build_docker_image
  image: jdrouet/docker-with-buildx:stable
  variables:
    DOCKER_DRIVER: overlay2
    DOCKER_TLS_CERTDIR: "/certs"
  services:
    - docker:dind
  before_script:
    - docker version
    # https://github.com/docker/buildx/issues/314
    # https://stackoverflow.com/questions/61430005/gitlab-ci-cd-building-multiarch-docker-images
    # https://github.com/docker/buildx/issues/413
    - docker run --rm --privileged multiarch/qemu-user-static --reset -p yes
    - docker context create tls-environment
    - docker buildx create --name multiarch-builder --use tls-environment
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker buildx build --platform linux/arm64,linux/amd64 -t $CI_REGISTRY_IMAGE:latest --push .
  when: manual
  rules:
    - if: $BUILD_DOCKER_IMAGE == "true" && $CI_COMMIT_BRANCH == "main"


deploy-production:
  stage: deploy
  image: kroniak/ssh-client
  environment:
    name: production
    url: https://yacsp.markovvn1.me/api/
  variables:
    SSH_PRIVATE_KEY: $SSH_PROD_PRIVATE_KEY
    SSH_HOST_ID: $SSH_PROD_HOST_ID
    SSH_TARGET: $SSH_PROD_TARGET
  before_script:
    - eval $(ssh-agent -s) > /dev/null  # Initiaize user agent
    - ssh-add - <<< "$SSH_PRIVATE_KEY"  # Add ssh key
    - mkdir -p ~/.ssh
    - echo "$SSH_HOST_ID" >> ~/.ssh/known_hosts
  script:
    - ssh $SSH_TARGET
  when: manual
  needs: [build_docker_image]
  rules:
      - if: $CI_COMMIT_BRANCH == "main"
